unit A_2022_11_05_Prog_190_Gestione_Stringhe_pas;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Edit1: TEdit;
    Edit_Numero_ASCII: TEdit;
    Edit_Stringa_da_scansionare: TEdit;
    Edit_Carattere: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label_Ascii: TLabel;
    Label_posizione: TLabel;
    Label_Codice_Carattere: TLabel;
    Label_N_Caratteri: TLabel;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure Edit_Stringa_da_scansionareChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
Var Carattere: String; // , Carat_1, Carat_2
Var Posizione, Valore, Codice_1, Codice_2 : Integer;
Var Trovato: Boolean;
begin
  // (1) Prima fase: Anzitutto controlla se è presente uno (e uno solo) carattere da cercare
  If Length(Edit_Carattere.text) > 0  then // Prosegue solo in presenza di stringhe lunghe un solo carattere
  //...che tuttavia possono essere rappresentate anche da due byte, come le vocali accentate.
  If Length(Edit_Carattere.text) = 2  then // Caso dei caratteri rappresentati da due byte, come appunto le vocali accentate
  Begin
      Begin
        Codice_1:= Integer(Ord(Edit_Carattere.Text[1])); // Valore del primo byte
        Codice_2:= Integer(Ord(Edit_Carattere.Text[2])); // Valore del secondo byte
        Memo1.Append ('I primi due codici corrispondenti al carattere "' + Edit_Carattere.text + '" sono: ' + IntToStr(Codice_1) + ' ' + IntToStr(Codice_2) + ' (N. byte del carattere: ' + IntToStr(Length(Edit_Carattere.text)) + ')');
        Label_posizione.Caption:= ('Impossibile trovare corrispondenza'); // Avverte sull'impossibilità di individuare la posizione
        Label_Codice_Carattere.Caption:= ('Valori dei due byte di "' + Edit_Carattere.text + '" : ' +IntToStr(Codice_1) + ' ' + IntToStr(Codice_2));
        Exit; // Esce dalla routine
      End;
  End
  Else
  // (2) Seconda fase: se la lunghezza di Edit_Carattere.text è maggiore di zero, ma non vale due, evidentemente(!) vale 1
  // Controlla la stringa da elaborare (contenuta in Edit_Carattere.Text) con l'insieme di caratteri (Edit_Stringa_da_esaminare.Text)
  Trovato:= False; // Deviatore che permette (vedi più avanti) di fare una scelta
  If Length(Edit_Stringa_da_scansionare.text) > 1  then  // Controlla (anche se inutile) se la lunghezza della stringa da esaminare (che contiene l'insieme dei caratteri) è maggiore almeno di un solo byte
     Begin
        If Trovato = False  Then
         For Posizione:= 1 to Length(Edit_Stringa_da_scansionare.Text) Do // Uno dopo l'altro esamina i caratteri presenti nella stringa da elaborare
           Begin
             Carattere:= Copy(Edit_Stringa_da_scansionare.Text,Posizione,1);
             If Carattere = Edit_Carattere.text then // Se c'è corrispondenza...
                Begin
                  Label_posizione.Caption:=(Carattere + ' è nella posizione n. ' + IntToStr(Posizione));
                  Valore:= Integer(Ord(Edit_Carattere.Text[1])); // Dermina il valore
                  Label_Codice_Carattere.Caption:= ('Il codice ASCII del carattere "' + Edit_Carattere.Text + '" è: ' + IntToStr(Valore)) ;
                  Memo1.Append ('Il codice corrispondente a "' + Edit_Carattere.text + '" è ' + IntToStr(Valore)); // Aggiunge al Memo
                  Exit; // Se trova corrispondenza "esce" dalla procedura.
                 End;
           End;
         Begin
           // La ricerca è iniziata con Trovato:= False. Se alla fine è ancora False vuol dire che non è stato trovato
             If Trovato = False then
             Begin
               Label_posizione.Caption := ('Il carattere '+ Edit_Carattere.text + ' non è presente nella stringa.');
               Memo1.Append ('Il carattere '+ Edit_Carattere.text + ' non è presente nella stringa. La sua lunghezza è di ' + IntToStr(Length(Edit_Carattere.text)) + ' bytes');
             end;
         End;
   end
      else Label_posizione.Caption := ('La stringa è vuota!'); // (B) Proviene da (A) e quindi la stringa da elaborare è vuota!
End;

procedure TForm1.Button2Click(Sender: TObject);
// Converte numero in carattere corrispondente
begin
  Label_Ascii.Caption:=(' Carattere di ' + Edit_Numero_ASCII.Text + ': ' + Chr((StrToInt(Edit_Numero_ASCII.text))));
  Memo1.Append ('Il carattere corrispondente al numero ' + Edit_Numero_ASCII.text + ' è ' + Chr((StrToInt(Edit_Numero_ASCII.text)))); // Aggiunge al Memo
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin

end;

procedure TForm1.Edit_Stringa_da_scansionareChange(Sender: TObject);
// Aggiornamento automatico del numero dei caratteri
begin
  // Ogni volta che si aggiunge / cancella / modifica un carattere, il contenuto della Label viene modificato in tempo reale
  Label_N_Caratteri.Caption:=('N. caratteri stringa: ' + IntToStr(Length(Edit_Stringa_da_scansionare.Text)));
end;

procedure TForm1.FormCreate(Sender: TObject);
// Proceduta attivata appena si lancia il programma
begin
  Label_N_Caratteri.Caption:=('N. caratteri stringa: ' + IntToStr(Length(Edit_Stringa_da_scansionare.Text)));
  Label_Codice_Carattere.Caption:=('Codice ASCII del carattere ' + Edit_Carattere.Text + ' è: ' + IntToStr(Integer(Ord(Edit_Carattere.Text[1]))));

end;

     end.

